<img src="forest-1.jpg" width=2000/><br>
# Exercise Sheet 3 - Decision Trees and Random Forest
Author: Samuel Innes <br>
Email: dd257@stud.uni-heidelberg.de

## <a href="03_üb.pdf">Link to Exercise sheet</a>

## Purpose
This program was written to investigate the influence of the _max_depth_ parameter on the outcome of the Decision Tree and Random Forest algorithms. 

## What does "label"(bezeichne) mean?
Labelling means assigning a name or pointer to a variable. In other words: we have an object (namely the training data points, which have been separated from the test data) und wish to give this object a name. 

## What predictions does the classifier make on X_test?
The classifier predicts whether a particular data point is in class A (0) or class B (1). An example prediction on the moons datasets is the following: `[0 0 0 0 0 1 0 0 0 0 0 1 1 1 1 1 0 1 1 1 1 1 0 0 1 0 1 1 1 0 1 0 1 1 1 1 0
 1 0 0]`.

## ...and with what accuracy?
With a max_depth = 7 I got these results (using a random.seed(1) for consistency and comparability):
| Datatype | Accuracy (Test data, Training data) |
| --- | ----------- |
| Moons | 0.95, 1.0 |
| Circles | 0.775, 1.0 |
| Linearly Separable | 0.925, 1.0|

## But what effect does maximum depth of the tree have?
In theory, the higher the maximum depth, the more precisely the model is fitted to the training data. Doing so however runs the danger of overfitting, and then getting a lower accuracy on the test set. Here is a table with the different values I used for maximum depth, and the highest accuracy for each data set in bold.

| max_depth | Moon | Circle | Linearly Separable |
| --------- | ---- | ------ | ------------------ |
| 1 | 0.75 | 0.65 | 0.925 |
| 2 | 0.9 | 0.675 | 0.925 |
| 3 | 0.9 | 0.65 | **0.95** |
| 4 | 0.85 | 0.725 | **0.95** |
| 5 | **0.95** | **0.8** | 0.925 |
| 6 | **0.95** | 0.775 | 0.925 |
| 7 | **0.95** | 0.775 | 0.925 |
| 8 | **0.95** | 0.775 | 0.925 |
| 9 | **0.95** | 0.775 | 0.925 |
| 10 | **0.95** | 0.775 | 0.925 |
| default | 0.95 | 0.8 | 0.95 |

Based off the data above, I would say that a max_depth = 5 is the optimum, since it highest average accuracy of the datasets for the test data, which is what we wish to calculate accuracy with as classifying unseen data is the whole point of machine learning.  

Concerning the visual effect of the max_depth on the decision boundaries: there are visible differences, however they are relatively small and hard to put into words, hence I have uploaded pictures of the plot. 
| with default max_depth | with max_depth = experimental_optimum |
| ---------------------- | ------------------------------------- |
| <img src="dt-optimum-dec-bound.JPG" width=100> | <img src="dt-optimum-dec-bound.JPG" width=100> |

With Decision Tree the accuracy only differs in the last dataset, where the default is 0.025% better than my experimental optimum of 5. This can be see on the plot above where with a max_depth of 5, a red data point is classed as blue, whereas with the default it is correctly classified as red.

### Here are the final test and train plots:
<img src="decision_tree_final.JPG" width=700>

## And what about Random Forest?
The decision boundaries of the Random Forest classifier are graded in their nature, which allows for a more nuanced classification. The accuracy on the test data is therefore indeed higher. The accuracy of Decision Trees on the training data with the experimental optimum is also lower on the Moon and Circle datasets. However this does mean that, since the decision boundaries of a Random Forest are graded and those for Decision Trees block, the latter would be more accurate in classifying data in the class region lying further away from the center of a particular cluster.

Finding the experimental optimum:
| max_depth | Moon | Circle | Linearly Separable |
| --------- | ---- | ------ | ------------------ |
| 1 | 0.9 | 0.7 | 0.9 |
| 2 | 0.9 | 0.825 | 0.925 |
| 3 | 0.925 | 0.825 | 0.9 |
| 4 | 0.925 | 0.8 | **0.95** |
| 5 | **0.95** | 0.825 | **0.95** |
| 6 | **0.95** | 0.825 | **0.95** |
| 7 | **0.95** | **0.85** | **0.95** |
| 8 | **0.95** | **0.85** | **0.95** |
| 9 | **0.95** | **0.85** | **0.95** |
| 10 | **0.95** | **0.85** | **0.95** |
| default | 0.95 | 0.825 | 0.95 |

Thus I would take 7 as the optimum, since it maximises the accuracy over all datasets on the test set.

The visual difference is, again, small but noticeable.
| with default max_depth | with max_depth = experimental_optimum |
| ---------------------- | ------------------------------------- |
| <img src="rf-optimum-dec-bound.JPG" width=100> | <img src="rf-optimum-dec-bound.JPG" width=100> |

It is somewhat harder to explain the 0.025% difference in accuracy in the circle dataset between the default and the experimental optimum in the Random Forest example, however it is clear, that with the experimental optimum, the boundaries are more finely grained, and the kern in the center is more filled with blue than in the default.

## Decision Tree with sklearn.tree.plot_tree
Here is an example Decision Tree for the Moon dataset:<br>
<img src="tree.JPG" width=300>

### And here are the final test and train plots:
<img src="randomforest_final.JPG" width=700>

# Final Project
## What problem do I wish to solve?
I wish to build an algorithm which takes in as input text written in Slavic language and classifies which language it is. 

## What data can be used to train the model?
Using a webscraping to extract text from wikipedia, I can create reliable text corpora, even for lesser spoken Slavic languages.

## What are the features?
The most obvious feature is vocabulary, since it incoporates other features such as characters, though is more fine-grained so as to be able to differentiate between languages with the same alphabet, and morphology, which is difficult to implement. Hence, using a bag of words approach, I can incorporate the most important features needed for language classification, without any language-specific knowledge.

## How can the performance be measured?
Splitting the corpus into training and test set allows the perfomance to be measured in a non-biased way. 

## Could a Decision Tree be used to solve this problem?
I believe that a Decision Tree would be a good approach. Since the languages themselves are grouped in a tree-structure, a Decision Tree is locally greedy and would therefore in theory model the historical linguistic development and development of different features well, thus modelling the structure of the problem itself. 

However, Decision Trees are often prone to overfitting, and if, with the bag of words approach trained on a corpus, a small text is used as input, this may cause inaccuracy.
