<img src="thread.jpg" width=2000/><br>
# Exercise Sheet 4 - Multiprocessing and project planning
Author: Samuel Innes <br>
Email: dd257@stud.uni-heidelberg.de

## <a href="04_üb.pdf">Link to Exercise sheet</a>

## Purpose
This program was written to practice and test multiprocessing in Python.

## How can the correct order of the output be ensured?
In order to solve this issue I used `jobs.append(executor.map(process, sub_list))`, rather than `jobs.append(executor.submit(process(sub_list)))`. `.map()` returns the outputs in the order they were submitted, whereas with `.submit()` and then `.as_completed()`, without any other mitigation measures (such as an index of submitted jobs), they are returned as soon as they are completed and not necessarily in the correct order. 

## Why does line 16 in multip_at_home_ORIGINAL.py not work?
```python
def process(list_of_lines):
    """ Does something item-wise to list_of_lines. """
    for i in range(0, 1000):
        for item in list_of_lines:
            item = item.lower()
    return list_of_lines
```
The above code takes as input a line as a list and iterates over every letter, converting it to lowercase and assigning it to the variable item. However these letters are not saved anywhere and hence are just overwritten with each iteration. The solution is therefore to create a new list (lower_lines in the example below) and append item to it each time. 

```python
def process(list_of_lines):
    """ Does something item-wise to list_of_lines. """
    for i in range(0, 1000):
        lower_lines = []
        for list in list_of_lines:
            lower_lines.append(list.lower())
    return lower_lines
```

## TODOs
In its current state, multip_at_home.py converts everything in multip_CAPS.py to lower case. However, this is not always wanted: for example with boolean values such as "True", and external classes such as ProcessPoolExecutor.

