import concurrent.futures
import time
from multiprocessing import freeze_support


def process(list_of_lines):
    """ Does something item-wise to list_of_lines. """
    for i in range(0, 1000):
        lower_lines = []
        for list in list_of_lines:
            lower_lines.append(list.lower())
    return lower_lines

if __name__ == '__main__':
    freeze_support()
    
    # script params
    n_worker = 4

    f = open("multip_CAPS.py", "r")
    content = f.readlines()
    n = len(content) // n_worker

    t1 = time.time()

    with concurrent.futures.ThreadPoolExecutor() as executor:
        jobs = []
        for i in range(n_worker):
            if i < n_worker - 1:
                sub_list = content[i * n:(i + 1) * n]
            else:
                sub_list = content[i * n:]
            jobs.append(executor.map(process, sub_list))

    with open("multipy.py", "w") as f:
        for sub_list in jobs:
            for line in sub_list:
                for letter in line:
                    f.write(letter)
    
    print("Elapsed time (with multiprocessing)", time.time() - t1)
