import time
import concurrent.futures

# script params
multiprocessing = true
# multiprocessing = false
if multiprocessing:
    n_worker = 4
else:
    n_worker = 1


# santa's plan
santa_list = range(7) # 7*10**9 # mit weniger 7 zahlen, show ordnung mess up
n = len(santa_list) // n_worker
total_len = 0


def magic(gift_list, which):
    for item in gift_list:
        print(item, which)
        item **= 2
    return which


t1 = time.time()

executortype = concurrent.futures.processpoolexecutor
with executortype() as executor:
    jobs = []
    for i in range(n_worker):
        if i < n_worker - 1:
            sub_list = santa_list[i * n:(i + 1) * n]
        else:
            sub_list = santa_list[i * n:]

        # track length of sublists to check if the splitting was successful
        total_len += len(sub_list)

        jobs.append(executor.submit(magic, sub_list, i))
    for job in concurrent.futures.as_completed(jobs):
        res = job.result()
        print(res)

assert total_len == len(santa_list)

print("elapsed time", time.time() - t1, "multiprocessing:", multiprocessing) 