# exp-ml-1
<img src="project/images/birch-forest.jpg" width=2000/>

# Experimente gestalten fürs Maschinelle Lernen
## Author
Samuel Innes: dd257@stud.uni-heidelberg.de
### About this repository:
This repository contains my exercise sheets and final project for <a href="https://lsf.uni-heidelberg.de/qisserver/rds?state=verpublish&status=init&vmfile=no&publishid=351133&moduleCall=webInfo&publishConfFile=webInfo&publishSubDir=veranstaltung">Letitia Parcalabescu's seminar on designing experiments for Machine Learning.</a> The seminar introduces basic Machine Learning concepts with sklearn, with one<a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/blob/master/README.md#progress"> exercise sheet</a> each week in the first half of the semester and a final project in the second half.

# Final Project: <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Slavic language classifier</a>
This project takes as input a text in a particular Slavic language and returns which language it is, including information about the linguistic classification of that language.

## Motivation
Although many language detectors already exist, there are, as far as I can tell, none which focus specifically on the Slavic language family and are thus able to detect less widely-spoken Slavic languages such as Lower Sorbian or Rusyn. However, using the fact that Wikipedia is available in many of these smaller languages, a classifier can be trained, as is explained below, to detect these minority languages. Such a classifier can help towards preservation of these languages, and can contribute to their digital presence, thus encouraging speakers to use them.

More information about the Slavic language classifier can be found <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">here</a>. 

## System Requirements
Computer<br>
Python 3.9 (or similar)<br>
Scikit-learn<br>

## Installation
Download the folder `model`. Make sure that the necessary sklearn packages are installed then run `detect_language.py`.

## Progress
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/01_%C3%BCbung">Exercise 1</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/02_%C3%BCbung">Exercise 2</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/03_%C3%BCbung">Exercise 3</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/04_%C3%BCbung">Exercise 4</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Exercise 5</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Exercise 6</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Exercise 7</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Exercise 8</a>
- [x] <a href="https://gitlab.cl.uni-heidelberg.de/innes/exp-ml-1/-/tree/master/project">Final Project</a>

