# This module plots a histogram depicting class frequencies

import re
import os
import numpy as np
import matplotlib.pyplot as plt 
from collections import Counter

CWD = os.getcwd()
LANG_LIST = ["ru", "pl", "uk", "sl", "sk", "sr", "bg", "be", "mk", "cs", "hr", "szl", "dsb", "hsb", "cu", "rue"]

with open(CWD + "/project/data/data.txt", "r") as f:
    data = f.read().strip().split("\t")

# extract data from data.txt
X = []
y = []
for dp in data:
    with_bracket = re.search("\([^a-zA-Z]+\)", dp).group()[1:]
    no_bracket = with_bracket.strip("(").strip(")").split(", ")
    X.append(np.array(no_bracket, dtype=np.int32))
    y.append(re.search("[a-zA-Z]+", dp).group())

# count occurences of each language
lang_count = Counter(y)
print(lang_count)

# plot as histogram
plt.bar(lang_count.keys(), lang_count.values())
plt.show()
