# this module prints classification report, with f1 scores for each class

import re
import os
import numpy as np

from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import multilabel_confusion_matrix, classification_report


CWD = os.getcwd()
LANG_LIST = ["ru", "pl", "uk", "sl", "sk", "sr", "bg", "be", "mk", "cs", "hr", "szl", "dsb", "hsb", "cu", "rue"]

# read training data
with open(CWD + "/project/data/train_data.txt", "r") as f:
    train_data = f.read().strip().split("\t")

# extract training data from train_data.txt
X_train = []
y_train = []
for dp in train_data:
    with_bracket = re.search("\([^a-zA-Z]+\)", dp).group()[1:]
    no_bracket = with_bracket.strip("(").strip(")").split(", ")
    X_train.append(np.array(no_bracket, dtype=np.int32))
    y_train.append(re.search("[a-zA-Z]+", dp).group())

# read test data
with open(CWD + "/project/data/test_data.txt", "r") as f:
    test_data = f.read().strip().split("\t")

# extract test data from test_data.txt
X_test = []
y_test = []
for dp in test_data:
    with_bracket = re.search("\([^a-zA-Z]+\)", dp).group()[1:]
    no_bracket = with_bracket.strip("(").strip(")").split(", ")
    X_test.append(np.array(no_bracket, dtype=np.int32))
    y_test.append(re.search("[a-zA-Z]+", dp).group())

# fit model and generate predictions
rfcf = RandomForestClassifier(random_state=0)
rfcf.fit(X_train,y_train)
y_pred = rfcf.predict(X_test)

cr = classification_report(y_test, y_pred)
print(cr)
#cm = multilabel_confusion_matrix(y_test, y_pred, labels=LANG_LIST) # print confusion matrix for each class
#print(cm)
