# this module plots a decision tree after training the classifier on the data

import re
import os

import numpy as np
import matplotlib.pyplot as plt

from sklearn import tree


CWD = os.getcwd()
LANG_LIST = ["ru", "pl", "uk", "sl", "sk", "sr", "bg", "be", "mk", "cs", "hr", "szl", "dsb", "hsb", "cu", "rue"]

# read data
with open(CWD + "/project/data/data.txt", "r") as f:
    data = f.read().strip().split("\t")

# extract data from data.txt
X = []
y = []
for dp in data:
    with_bracket = re.search("\([^a-zA-Z]+\)", dp).group()[1:]
    no_bracket = with_bracket.strip("(").strip(")").split(", ")
    X.append(np.array(no_bracket, dtype=np.int32))
    y.append(re.search("[a-zA-Z]+", dp).group())

dtcf = tree.DecisionTreeClassifier()
dtcf.fit(X,y)
plt.figure()
plt.title("Decision tree")
tree.plot_tree(dtcf, 
                    class_names=LANG_LIST,
                    filled=True)
plt.show()

text_repr = tree.export_text(dtcf)
print(text_repr)

